=== debian/control ===
Source: ros-noetic-tesseract-kinematics
Section: misc
Priority: optional
Maintainer: Levi Armstrong <levi.armstrong@swri.org>
Build-Depends: debhelper (>= 9.0.0), cmake, libconsole-bridge-dev, libeigen3-dev, libgtest-dev <!nocheck>, liblapack-dev <!nocheck>, liborocos-kdl-dev, libyaml-cpp-dev, ros-noetic-opw-kinematics, ros-noetic-ros-industrial-cmake-boilerplate, ros-noetic-tesseract-common, ros-noetic-tesseract-scene-graph, ros-noetic-tesseract-state-solver, ros-noetic-tesseract-support <!nocheck>, ros-noetic-tesseract-urdf <!nocheck>
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-tesseract-kinematics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libconsole-bridge-dev, libeigen3-dev, liborocos-kdl-dev, libyaml-cpp-dev, ros-noetic-opw-kinematics, ros-noetic-tesseract-common, ros-noetic-tesseract-scene-graph, ros-noetic-tesseract-state-solver
Description: The tesseract_kinematics package contains kinematics related libraries.
